PLASMA 2.8.0 PLASMA - Parallel Linear Algebra for Scalable Multi-core Architectures

- Main Page
- Modules
- Data Types List

int PLASMA_sgesvd | ( | PLASMA_enum | jobu,
|  | PLASMA_enum | jobvt,
|  | int | M,
|  | int | N,
|  | float * | A,
|  | int | LDA,
|  | float * | S,
|  | PLASMA_desc * | descT,
|  | float * | U,
|  | int | LDU,
|  | float * | VT,
|  | int | LDVT
| ) |  |

PLASMA_sgesvd - computes the singular value decomposition (SVD) of a complex M-by-N matrix A, optionally computing the left and/or right singular vectors. The SVD is written

     A = U * SIGMA * transpose(V)

where SIGMA is an M-by-N matrix which is zero except for its min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and V is an N-by-N orthogonal matrix. The diagonal elements of SIGMA are the singular values of A; they are real and non-negative, and are returned in descending order. The first min(m,n) columns of U and V are the left and right singular vectors of A.

Note that the routine returns V**T, not V.

Parameters

  [in] | jobu | Specifies options for computing all or part of the matrix U. Intended usage: = PlasmaVec = 'A'(lapack): all M columns of U are returned in array U; = PlasmaNoVec = 'N': no columns of U (no left singular vectors) are computed. = PlasmaSVec = 'S': the first min(m,n) columns of U (the left singular vectors) are returned in the array U; NOT SUPPORTTED YET = PlasmaOVec = 'O': the first min(m,n) columns of U (the left singular vectors) are overwritten on the array A; NOT SUPPORTTED YET
  [in] | jobvt | Specifies options for computing all or part of the matrix V**T. Intended usage: = PlasmaVec = 'A'(lapack): all N rows of V**T are returned in the array VT; = PlasmaNoVec = 'N': no rows of V**T (no right singular vectors) are computed. = PlasmaSVec = 'S': the first min(m,n) rows of V**T (the right singular vectors) are returned in the array VT; NOT SUPPORTTED YET = PlasmaOVec = 'O': the first min(m,n) rows of V**T (the right singular vectors) are overwritten on the array A; NOT SUPPORTTED YET

Note: jobu and jobvt cannot both be PlasmaOVec.

Parameters

  [in] | M | The number of rows of the matrix A. M >= 0.
  [in] | N | The number of columns of the matrix A. N >= 0.
  [in,out] | A | On entry, the M-by-N matrix A. On exit, if JOBU = 'O', A is overwritten with the first min(m,n) columns of U (the left singular vectors, stored columnwise); if JOBVT = 'O', A is overwritten with the first min(m,n) rows of V**T (the right singular vectors, stored rowwise); if JOBU .ne. 'O' and JOBVT .ne. 'O', the contents of A are destroyed.
  [in] | LDA | The leading dimension of the array A. LDA >= max(1,M).
  [out] | S | The real singular values of A, sorted so that S(i) >= S(i+1).
  [in,out] | descT | On entry, descriptor as return by PLASMA_Alloc_Workspace_sgesvd On exit, contains auxiliary factorization data.
  [out] | U | (LDU,M) if JOBU = 'A' or (LDU,min(M,N)) if JOBU = 'S'. If JOBU = 'A', U contains the M-by-M unitary matrix U; if JOBU = 'S', U contains the first min(m,n) columns of U (the left singular vectors, stored columnwise); if JOBU = 'N' or 'O', U is not referenced.
  [in] | LDU | The leading dimension of the array U. LDU >= 1; if JOBU = 'S' or 'A', LDU >= M.
  [out] | VT | If JOBVT = 'A', VT contains the N-by-N unitary matrix V**T; if JOBVT = 'S', VT contains the first min(m,n) rows of V**T (the right singular vectors, stored rowwise); if JOBVT = 'N' or 'O', VT is not referenced.
  [in] | LDVT | The leading dimension of the array VT. LDVT >= 1; if JOBVT = 'A', LDVT >= N; if JOBVT = 'S', LDVT >= min(M,N).

Returns

Return values

  PLASMA_SUCCESS | successful exit
  <0 | if -i, the i-th argument had an illegal value

See also
  PLASMA_sgesvd_Tile
  PLASMA_sgesvd_Tile_Async
  PLASMA_cgesvd
  PLASMA_dgesvd
  PLASMA_sgesvd